package com.example.forgottenumbrella.cardboardmuseum

import android.content.Context
import android.util.Log

/**
 * Exception type for API errors from the imageboard.
 */
class ApiException(message: String?) : Exception(message) {
    /**
     * Return the localised reason for the error.
     */
    fun getLocalisedMessage(context: Context) =
        when (val message = localizedMessage) {
            "authentication failed" -> context.getString(R.string.notification_error_authentication_text)
            "You cannot search for more than 2 tags at a time" ->
                context.getString(R.string.notification_error_limit_text)

            "" -> {
                Log.wtf(LOG_TAG, "Empty error message")
                message
            }

            null -> {
                Log.wtf(LOG_TAG, "Null error message")
                ""
            }

            else -> {
                Log.wtf(LOG_TAG, "Missing localisation: $message")
                message
            }
        }
}
